gi-gio-2.0.32: Gio bindings

Copyright | Will Thompson and Iñaki García Etxebarria
License | LGPL-2.1
Maintainer | Iñaki García Etxebarria
Safe Haskell | Safe-Inferred
Language | Haskell2010

GI.Gio.Objects.FileOutputStream

Contents

- Exported types
- Methods
  - getEtag
  - queryInfo
  - queryInfoAsync
  - queryInfoFinish

Description

`GFileOutputStream` provides output streams that write their content to a file.

`GFileOutputStream` implements `Seekable`, which allows the output stream to jump to arbitrary positions in the file and to truncate the file, provided the filesystem of the file supports these operations.

To find the position of a file output stream, use `seekableTell`. To find out if a file output stream supports seeking, use `seekableCanSeek`.To position a file output stream, use `seekableSeek`. To find out if a file output stream supports truncating, use `seekableCanTruncate`. To truncate a file output stream, use `seekableTruncate`.

Synopsis

- newtype FileOutputStream = FileOutputStream (ManagedPtr FileOutputStream)
- class (GObject o, IsDescendantOf FileOutputStream o) => IsFileOutputStream o
- toFileOutputStream :: (MonadIO m, IsFileOutputStream o) => o -> m FileOutputStream
- fileOutputStreamGetEtag :: (HasCallStack, MonadIO m, IsFileOutputStream a) => a -> m (Maybe Text)
- fileOutputStreamQueryInfo :: (HasCallStack, MonadIO m, IsFileOutputStream a, IsCancellable b) => a -> Text -> Maybe b -> m FileInfo
- fileOutputStreamQueryInfoAsync :: (HasCallStack, MonadIO m, IsFileOutputStream a, IsCancellable b) => a -> Text -> Int32 -> Maybe b -> Maybe AsyncReadyCallback -> m ()
- fileOutputStreamQueryInfoFinish :: (HasCallStack, MonadIO m, IsFileOutputStream a, IsAsyncResult b) => a -> b -> m FileInfo

# Exported types

newtype FileOutputStream Source #

Memory-managed wrapper type.

Constructors

FileOutputStream (ManagedPtr FileOutputStream) |

#### Instances

Instances details

Eq FileOutputStream Source # |
Instance details Defined in GI.Gio.Objects.FileOutputStream Methods (==) :: FileOutputStream -> FileOutputStream -> Bool Source # (/=) :: FileOutputStream -> FileOutputStream -> Bool Source #
GObject FileOutputStream Source # |
Instance details Defined in GI.Gio.Objects.FileOutputStream
ManagedPtrNewtype FileOutputStream Source # |
Instance details Defined in GI.Gio.Objects.FileOutputStream Methods toManagedPtr :: FileOutputStream -> ManagedPtr FileOutputStream Source #
TypedObject FileOutputStream Source # |
Instance details Defined in GI.Gio.Objects.FileOutputStream Methods glibType :: IO GType Source #
HasParentTypes FileOutputStream Source # |
Instance details Defined in GI.Gio.Objects.FileOutputStream
IsGValue (Maybe FileOutputStream) Source # | Convert `FileOutputStream` to and from `GValue`. See `toGValue` and `fromGValue`.
Instance details Defined in GI.Gio.Objects.FileOutputStream Methods gvalueGType_ :: IO GType Source # gvalueSet_ :: Ptr GValue -> Maybe FileOutputStream -> IO () Source # gvalueGet_ :: Ptr GValue -> IO (Maybe FileOutputStream) Source #
type ParentTypes FileOutputStream Source # |
Instance details Defined in GI.Gio.Objects.FileOutputStream type ParentTypes FileOutputStream = '[OutputStream, Object, Seekable]

class (GObject o, IsDescendantOf FileOutputStream o) => IsFileOutputStream o Source #

Type class for types which can be safely cast to `FileOutputStream`, for instance with `toFileOutputStream`.

#### Instances

Instances details

(GObject o, IsDescendantOf FileOutputStream o) => IsFileOutputStream o Source # |
Instance details Defined in GI.Gio.Objects.FileOutputStream

toFileOutputStream :: (MonadIO m, IsFileOutputStream o) => o -> m FileOutputStream Source #

Cast to `FileOutputStream`, for types for which this is known to be safe. For general casts, use `castTo`.

# Methods

### Click to display all available methods, including inherited ones

Expand

#### Methods

bindProperty, bindPropertyFull, canSeek, canTruncate, clearPending, close, closeAsync, closeFinish, flush, flushAsync, flushFinish, forceFloating, freezeNotify, getv, hasPending, isClosed, isClosing, isFloating, notify, notifyByPspec, queryInfo, queryInfoAsync, queryInfoFinish, ref, refSink, runDispose, seek, splice, spliceAsync, spliceFinish, stealData, stealQdata, tell, thawNotify, truncate, unref, watchClosure, write, writeAll, writeAllAsync, writeAllFinish, writeAsync, writeBytes, writeBytesAsync, writeBytesFinish, writeFinish, writev, writevAll, writevAllAsync, writevAllFinish, writevAsync, writevFinish.

#### Getters

getData, getEtag, getProperty, getQdata.

#### Setters

setData, setDataFull, setPending, setProperty.

## getEtag

fileOutputStreamGetEtag Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileOutputStream a) |
=> a | `stream`: a `FileOutputStream`.
-> m (Maybe Text) | Returns: the entity tag for the stream.

Gets the entity tag for the file when it has been written. This must be called after the stream has been written and closed, as the etag can change while writing.

## queryInfo

fileOutputStreamQueryInfo Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileOutputStream a, IsCancellable b) |
=> a | `stream`: a `FileOutputStream`.
-> Text | `attributes`: a file attribute query string.
-> Maybe b | `cancellable`: optional `Cancellable` object, `Nothing` to ignore.
-> m FileInfo | Returns: a `FileInfo` for the `stream`, or `Nothing` on error. (Can throw `GError`)

Queries a file output stream for the given `attributes`. This function blocks while querying the stream. For the asynchronous version of this function, see `fileOutputStreamQueryInfoAsync`. While the stream is blocked, the stream will set the pending flag internally, and any other operations on the stream will fail with `IOErrorEnumPending`.

Can fail if the stream was already closed (with `error` being set to `IOErrorEnumClosed`), the stream has pending operations (with `error` being set to `IOErrorEnumPending`), or if querying info is not supported for the stream's interface (with `error` being set to `IOErrorEnumNotSupported`). In all cases of failure, `Nothing` will be returned.

If `cancellable` is not `Nothing`, then the operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, the error `IOErrorEnumCancelled` will be set, and `Nothing` will be returned.

## queryInfoAsync

fileOutputStreamQueryInfoAsync Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileOutputStream a, IsCancellable b) |
=> a | `stream`: a `FileOutputStream`.
-> Text | `attributes`: a file attribute query string.
-> Int32 | `ioPriority`: the I/O priority of the request
-> Maybe b | `cancellable`: optional `Cancellable` object, `Nothing` to ignore.
-> Maybe AsyncReadyCallback | `callback`: callback to call when the request is satisfied
-> m () |

Asynchronously queries the `stream` for a `FileInfo`. When completed, `callback` will be called with a `AsyncResult` which can be used to finish the operation with `fileOutputStreamQueryInfoFinish`.

For the synchronous version of this function, see `fileOutputStreamQueryInfo`.

## queryInfoFinish

fileOutputStreamQueryInfoFinish Source #

Arguments

:: (HasCallStack, MonadIO m, IsFileOutputStream a, IsAsyncResult b) |
=> a | `stream`: a `FileOutputStream`.
-> b | `result`: a `AsyncResult`.
-> m FileInfo | Returns: A `FileInfo` for the finished query. (Can throw `GError`)

Finalizes the asynchronous query started by `fileOutputStreamQueryInfoAsync`.